#include "testlib.h"
#include <iostream>
#include <random>

using namespace std;

#define pb push_back
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())

typedef long long ll;
typedef pair<int, int> pii;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int n;
    n = atoi(argv[1]);

    vector<int> a(n);

    for (auto &i : a) i = rnd.next(-1000000000, 1000000000);

    int ind = rnd.next(0, n - 1);
    if (a[ind] % 2 == 0) {
        if (rnd.next(0, 1)) ++a[ind];
        else --a[ind];
        a[ind] %= 1000000000;
    }
    cout << n << '\n';
    for (int i = 0; i < n; ++i) {
        cout << a[i];
        if (i < n - 1) cout << ' ';
    }
    cout << '\n';
    return 0;
}
