package main

import (
	"bufio"
	"fmt"
	"os"
)

var reader *bufio.Reader = bufio.NewReader(os.Stdin)
var writer *bufio.Writer = bufio.NewWriter(os.Stdout)

func printf(f string, a ...interface{}) {
	fmt.Fprintf(writer, f, a...)
}
func scanf(f string, a ...interface{}) {
	fmt.Fscanf(reader, f, a...)
}

func main() {
	defer writer.Flush()

	var n, i uint32
	var x int32
	scanf("%d\n", &n)
	for i = 0; i < n; i++ {
		scanf("%d", &x)
		if x & 1 != 0 {
			break
		} else if i > 0 {
			printf("x")
		}
	}
	if i > 0 {
		printf("+")
	}
	for i++; i < n; i++ {
		scanf("%d", &x)
		if ^x & 1 != 0 {
			break
		} else {
			printf("x")
		}
	}
	if i < n {
		printf("+")
	}
	for i++; i < n; i++ {
		printf("x")
	}
}
