#include "testlib.h"

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    // Now there are three global variables specifying testlib streams:
    // inf - stream with the testdata.
    // ouf - stream with the contestant output.
    // ans - stream with the jury answer.
    // All those streams provide the similar interface for reading data.
    int t = inf.readInt();
    for (int i = 0; i < t; ++i) {
        int pans = ouf.readInt();
        int jans = ans.readInt();
        if (pans != jans) {
            quitf(_wa, "Answer on test %d in incorrect", i + 1);
        }
    }
    quitf(_ok, "Ok, you are awesome");
}
