#include <vector>
#include <algorithm>
#include "testlib.h"

using namespace std;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int t = inf.readInt(1, 1000, "tests count");
    inf.readEoln();
    int sum = 0;
    for (int i = 0; i < t; ++i) {
        int n = inf.readInt(1, 5'000, "dots count");
        inf.readEoln();
        sum += n;
        vector<long long> numbers;
        for (int j = 0; j < n; ++j) {
            if (j)
                inf.readSpace();
                long long a = inf.readLong(0ll, 1'000'000'000'000'000'000, "dot");
                numbers.push_back(a);
            }
        sort(numbers.begin(), numbers.end());
        numbers.erase(unique(numbers.begin(), numbers.end()), numbers.end());
        ensuref(numbers.size() == n, "two equal numbers");
        inf.readEoln();
    }
    inf.readEof();
    ensuref(sum <= 30'000, "sum is too big");
    ensuref(sum <= 30'000, "sum is too big");
}
