#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <fstream>
#include <iomanip>
#include <bitset>
#include <random>
#include <queue>
#include <cstring>
#include <cassert>

using namespace std;

#define X first
#define Y second
#define mp make_pair
#define all(x) x.begin(), x.end()
#define all_(x) x.rbegin(), x.rend()
#define multi_test 1

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

const ll INF = 1e9 + 9;
const ll MAXN = 5e3 + 7;
const ll MAXN1 = 1 << 10;
const ll MAXN2 = 1e6 + 7;
const ll MOD = 1e9 + 7;
const ll PW = 31;
const ll BLOCK = 317;

void solve();
mt19937_64 mt(1e9 + 7);

signed main() {
    srand('a' + 'l' + 'e' + 'x' + 'X' + '5' + '1' + '2');
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
#define MAXN 5000
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    if (multi_test) cin >> q;
    while (q--)  {
        solve();
    }
}

/*-----------------------------------------------------------------------------------------------------------------------------*/

ll points[MAXN];
int sz[MAXN];
vector<pair<ll, int>> dp[MAXN];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> points[i];
        if (dp[i].size() != i + 1) dp[i].resize(i + 1);
        sz[i] = 1;
    }
    sort(points, points + n);
    reverse(points, points + n);
    dp[0][0] = mp(0, 1);
    for (int i = 1; i < n; ++i) {
        dp[i][0] = mp(0, 1);
        for (int j = i - 1; j >= 0; --j) {
            auto it = lower_bound(dp[j].begin(), dp[j].begin() + sz[j], mp(points[j] - points[i], 0));
            --it;
            if (dp[i][sz[i] - 1].Y < it->Y + 1) {
                dp[i][sz[i]] = mp(points[j] - points[i], it->Y + 1);
                ++sz[i];
            }
        }
    }
    cout << dp[n - 1][sz[n - 1] - 1].Y << "\n";
}
