#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 100, Q = 2e5 + 100;

int n, q, added = 0;
int open[N], close[N], query[Q];
map <int, int> res;
vector <int> id;

int get_black(int t) {
	int res = 0;
	for (auto j : id) {
		res += open[j] < open[t] && close[j] == -1 && open[j] != -1;
	}
	return res;
}

int get_outside(int t) {
	int res = 0;
	for (auto i : id) {
		res += open[i] < open[t] && close[t] < close[i] && close[i] != -1;
	}
	return res;
}

int get_left(int t) {
	int res = 0;
	for (auto i : id) {
		res += (int)(open[i] < open[t] && close[i] < close[t] && open[t] < close[i] && close[i] != -1);
	}
	return res;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cin >> n >> q;
	fill_n(open, n, -1);
	fill_n(close, n, -1);
	for (int i = 0; i < q; i++) {
		string z;
		int t;
		cin >> z >> t; t--;
		query[i] = t;
		if (z == "add") {
			added++;
			open[t] = i;
			id.push_back(t);
		} else {
			close[t] = i;
		}
	}

	long long ans = 0;
	deque <int> d;
	for (int i = 0; i < q; i++) {
		int t = query[i];
		int z = (i != open[t]);
		if (z == 0) {
			if (close[t] == -1 || get_black(t) + get_outside(t) < get_left(t)) {
				d.push_back(t);
				res[t] = 1;
			} else {
				d.push_front(t);
				res[t] = 0;
			}
		} else {
			stack <int> temp;
			while (!d.empty() && d.front() != t) {
				temp.push(d.front());
				d.pop_front();
				ans++;
			}
			assert(!d.empty());
			d.pop_front();
			ans++;
			while (!temp.empty()) {
				d.push_front(temp.top());
				temp.pop();
				ans++;
			}
		}
	}
	ans += added;
	cout << ans << '\n';
	return 0;
}
