#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int n;
vector<int> a;

inline void readAndCheckAnswer(InStream& in) {
	string s = in.readLine("[+,x]{1,99999}");
	if (int(s.length()) != n - 1)
		in.quitf(_wa, "Length must be exactly n - 1");
	vector<int> st = {a[0]};
	for (int i = 0; i < n - 1; ++i) {
		if (s[i] == '+') st.push_back(a[i + 1]);
		else st.back() *= a[i + 1];
	}
	int sum = 0;
	for (auto i : st) sum ^= i;
	if (sum != 1) in.quitf(_wa, "Result is not odd");
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    
    n = inf.readInt();
    a = vector<int>(n);
    for (auto &i : a) i = inf.readInt() & 1;

    readAndCheckAnswer(ans);
    readAndCheckAnswer(ouf);
    
    quitf(_ok, "n=%d", n);
}
