#include "testlib.h"

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    // Now there are three global variables specifying testlib streams:
    // inf - stream with the testdata.
    // ouf - stream with the contestant output.
    // ans - stream with the jury answer.
    // All those streams provide the similar interface for reading data.

    int n = inf.readInt();
    int pansMin = ouf.readInt(1, n, "participant min ans");
    int pansMax = ouf.readInt(1, n, "participant max ans");
    int jansMin = ans.readInt(1, n, "jury min ans");
    int jansMax = ans.readInt(1, n, "jury max ans");
    if (pansMin != jansMin) {
        quitf(_wa, "Min ans in incorrect");
    }
    if (pansMax != jansMax) {
        quitf(_wa, "Max ans is incorrect");
    }
    quitf(_ok, "Ok, you are awesome");
}
