package main

import (
	"bufio"
	"fmt"
	"sort"
	"os"
)

var (
	reader *bufio.Reader = bufio.NewReader(os.Stdin)
	writer *bufio.Writer = bufio.NewWriter(os.Stdout)
)

func printf(f string, a ...interface{}) {
	fmt.Fprintf(writer, f, a...)
}

func scanf(f string, a ...interface{}) {
	fmt.Fscanf(reader, f, a...)
}

func main() {
	defer writer.Flush()
	var (
		n, k int
		a []int
		x int
		mn, mx int = 1, 1
		p, q int = 0, 0
	)
	scanf("%d\n%d\n", &n, &k)
	for i := 0; i < n - 1; i++ {
		scanf("%d", &x)
		a = append(a, x)
	}
	sort.Ints(a)
	for i := 1; i < k; i++ {
		if a[p] < i {
			p++
		} else {
			mn++
		}
		for q < n - 1 && a[q] < i {
			q++
		}
		if q < n - 1 {
			q++
			mx++
		}
	}
	printf("%d\n%d", mn, mx)
}
