//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("O3")
#include<bits/stdc++.h>

using ll = long long int;
using ull = unsigned long long int;
using dd = double;
using ldd = long double;

namespace Mods {

const int mod197 = 1e9 + 7;
const int mod199 = 1e9 + 9;
const int modfft = 998244353;
int MOD = mod197;

void Hplus(int& h, int b, int mod = MOD) {
    h += b;
    if (h > mod)
        h -= mod;
}

void Hminus(int& h, int b, int mod = MOD) {
    h -= b;
    if (h < 0)
        h += mod;
}

void Hmuliply(int& h, int b, int mod = MOD) {
    h = (1LL * h * b) % mod;
}

ll binPow(ll a, ll n, int mod = MOD) {
    ll ans = 1;
    while (n > 1) {
        if (n & 1)
            ans = ans * a % mod;
        n >>= 1;
        a = a * a % mod;
    }
    if (n)
        ans = ans * a % mod;
    return ans;
}
}

namespace someUsefull {
template<typename T1, typename T2>
inline void checkMin(T1& a, T2 b) {
    if (a > b)
        a = b;
}

template<typename T1, typename T2>
inline void checkMax(T1& a, T2 b) {
    if (a < b)
        a = b;
}
}

//name spaces
using namespace std;
using namespace Mods;
using namespace someUsefull;
//end of name spaces

//defines
#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()

#define NO cout << "NO" << '\n';
#define No cout << "No" << '\n';
#define YES cout << "YES" << '\n';
#define Yes cout << "Yes" << '\n';
//end of defines


//debug defines
#ifdef HOME
    #define debug(x) cout << #x << " " << x << endl;
    #define debug_p(x) cout << #x << " " << x.ff << " " << x.ss << endl;
    #define debug_v(x) {cout << #x << " "; for (auto ioi : x) cout << ioi << " "; cout << endl;}
    #define debug_vp(x) {cout << #x << " "; for (auto ioi : x) cout << '[' << ioi.ff << " " << ioi.ss << ']'; cout << endl;}
    #define debug_v_v(x) {cout << #x << "/*\n"; for (auto ioi : x) { for (auto ioi2 : ioi) cout << ioi2 << " "; cout << '\n';} cout << "*/" << #x << endl;}
    int jjj;
    #define wait() cin >> jjj;
    #define PO cout << "POMELO" << endl;
    #define OL cout << "OLIVA" << endl;
    #define gen_clock(x) ll x = clock(); cout << "Clock " << #x << " created" << endl;
    #define check_clock(x) cout << "Time spent in " << #x << ": " << clock() - x << endl; x = clock();
    #define reset_clock(x) x = clock();
    #define say(x) cout << x << endl;
    #define check(x) {if (!(x)) cout << #x << " " << "was failed!" << endl;}
    #define castom(x) {x;}
#else
    #define debug(x) 0;
    #define debug_p(x) 0;
    #define debug_v(x) 0;
    #define debug_vp(x) 0;
    #define debug_v_v(x) 0;
    #define wait() 0;
    #define PO 0;
    #define OL 0;
    #define gen_clock(x) 0;
    #define check_clock(x) 0;
    #define reset_clock(x) 0;
    #define say(x) 0;
    #define check(x) 0;
    #define castom(x) 0;
#endif // HOME
//end of debug defines

ll arr[5000];
short int memory[5000 * 2600];
short int* dp[5000];
short int mans[5000];
short int sz[5000];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> arr[i];
    sort(arr, arr + n);
    reverse(arr, arr + n);
    for (int i = 0; i < n; ++i) {
        sz[i] = 0;
        mans[i] = 0;
        for (int j = 0; j <= i; ++j)
            dp[i][j] = -1;
        dp[i][0] = i;
        int k = 1;
        for (int j = i - 1; j >= 0; --j) {
            while (sz[j] <= mans[j] && arr[dp[j][sz[j]]] - arr[j] < arr[j] - arr[i])
                ++sz[j];
            checkMax(dp[i][sz[j]], j);
            checkMax(mans[i], sz[j]);
        }
        for (int j = mans[i] - 1; j >= 0; --j) {
            checkMax(dp[i][j], dp[i][j + 1]);
        }
    }
    cout << mans[n - 1] + 1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    int t;
    t = 1;
    int c = 0;
    for (int i = 0; i < 5000;) {
        dp[i] = memory + c;
        c += (++i) + 1;
    }
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;

}
/*



*/
