#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <fstream>
#include <iomanip>
#include <bitset>
#include <random>
#include <queue>
#include <cstring>
#include <cassert>

using namespace std;

#define X first
#define Y second
#define mp make_pair
#define all(x) x.begin(), x.end()
#define all_(x) x.rbegin(), x.rend()
#define multi_test 1

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

const ll INF = 1e9 + 9;
const ll MAXN = 5e3 + 7;
const ll MAXN1 = 1 << 10;
const ll MAXN2 = 1e6 + 7;
const ll MOD = 1e9 + 7;
const ll PW = 31;
const ll BLOCK = 317;

void solve();
mt19937_64 mt(1e9 + 7);

signed main() {
    srand('a' + 'l' + 'e' + 'x' + 'X' + '5' + '1' + '2');
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
#define MAXN 5000
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    if (multi_test) cin >> q;
    while (q--)  {
        solve();
    }
}

/*-----------------------------------------------------------------------------------------------------------------------------*/

void solve() {
    int n;
    cin >> n;
    vector<ll> v(n);
    for (auto &i : v) cin >> i;
    sort(all(v));
    ll ans = 0;
    for (int i = 1; i < (1 << n); ++i) {
        ll cnt = 0, last = -1, now = -1;
        for (int j = 0; j < n; ++j) {
            if (i & (1 << j)) {
                ++cnt;
                if (last != -1 && now - last <= v[j] - now) {
                    cnt = 0;
                    break;
                }
                last = now;
                now = v[j];
            }
        }
        ans = max(ans, cnt);
    }
    cout << ans << "\n";
}
