#include "testlib.h"
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);
	int q = atoi(argv[1]);
	int maxval = atoi(argv[2]);
	int n = 0;
	vector<pair<string, int>> input;
	vector<int> available;
	for (int i = 0; i < maxval; i++) {
		available.push_back(i + 1);
	}
	vector<int> added;
	q /= 5;
	for (int i = 0; i < q; i++) {
		int rnd_ind = rnd.next(available.size());
		int rnd_el = available[rnd_ind];
		swap(available[rnd_ind], available.back());
		available.pop_back();
		input.push_back(pair<string, int>("add", rnd_el));
		n = max(rnd_el, n);
	}
	for (int i = 0; i < 2 * q; i++) {
		int rnd_ind = rnd.next(available.size());
		int rnd_el = available[rnd_ind];
		swap(available[rnd_ind], available.back());
		available.pop_back();
		added.push_back(rnd_el);
		input.push_back(pair<string, int>("add", rnd_el));
		n = max(rnd_el, n);
	}
	for (auto el : added) {
		input.push_back(pair<string, int>("del", el));
	}
	cout << n << ' ' << 5 * q << '\n';
	for (auto el : input) {
		cout << el.first << ' ' << el.second << '\n';
	}
}
