#include "testlib.h"
#include <iostream>
#include <vector>

using namespace std;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);
	int q = atoi(argv[1]);
	int maxval = atoi(argv[2]);
	int maxsize = atoi(argv[3]);
	cout << maxval << ' ' << q << '\n';
	vector<int> available;
	for (int i = 0; i < maxval; i++) {
		available.push_back(i + 1);
	}
	vector<int> added;
	for (int i = 0; i < q; i++) {
		int flag = rnd.next(2);
		if ((added.empty() || flag) && !available.empty() &&
			added.size() < maxsize) {
			int rnd_ind = rnd.next(available.size());
			int rnd_el = available[rnd_ind];
			swap(available[rnd_ind], available.back());
			available.pop_back();
			cout << "add " << rnd_el << '\n';
			added.push_back(rnd_el);
		}
		else {
			int rnd_ind = rnd.next(added.size());
			int rnd_el = added[rnd_ind];
			swap(added[rnd_ind], added.back());
			added.pop_back();
			cout << "del " << rnd_el << '\n';
		}
	}
}
