#include "testlib.h"

using namespace std;

const int Q = 2e5, N = 2e5;

int used[N];

int main()
{
    registerValidation();

    int n = inf.readInt(1, N);
    inf.readSpace();
    int q = inf.readInt(1, Q);
    inf.readEoln();

    for (int i = 0; i < q; i++) 
    {
        string str = inf.readWord();
        ensure(str == "add" || str == "del");
        inf.readSpace();
        int t = inf.readInt(1, n);
        inf.readEoln();
        ensure((str == "add" && used[t] == 0) || (str == "del" && used[t] == 1));
        used[t]++;
    }
    inf.readEof();
    return 0;
}
