#include <iostream>
#include <string>
#include <vector>
#include <deque>
using namespace std;

vector<pair<string, int>> queries;
const long long INF = 1e18 + 228;

signed main() {
	int n, q;
	cin >> n >> q;
	int add_q = 0;
	for (int i = 0; i < q; i++) {
		string query;
		int x;
		cin >> query >> x;
		queries.push_back(pair<string, int>(query, x));
		add_q += query == "add";
	}
	long long glob_ans = INF;
	if (add_q > 25) {
	    while (true) {
	        add_q++;
	    }
	}
	for (int mask = 0; mask < (1 << add_q); mask++) {
	    deque<int> dq;
		long long ans = 0;
		int bit = 0;
		for (auto p : queries) {
			int x = p.second;
			if (p.first == "del") {
				int cnt = 0;
				vector<int> save;
				while (dq.front() != x) {
					cnt++;
					save.push_back(dq.front());
					dq.pop_front();
				}
				dq.pop_front();
				ans += 2 * cnt + 1;
				for (int i = save.size() - 1; i >= 0; i--) {
					dq.push_front(save[i]);
				}
			} else {
				ans += 1;
				if ((mask | (1 << bit)) == mask) {
					dq.push_back(x);
				} else {
					dq.push_front(x);
				}
			    bit++;
			}
		}
		glob_ans = min(ans, glob_ans);
	}
	cout << glob_ans << '\n';
	return 0;
}
