#include <bits/stdc++.h>

using namespace std;

template <typename T1, typename T2> inline bool chkMin(T1 &x, T2 y) { return x > y ? (x = y, true): false; }

const int N = 1e5 + 100, Q = 1e5 + 100;
const long long INF = 1e16 + 100;

int n, q;

map <deque <int>, long long> dp[Q];

int main() {
    cin >> n >> q;
    vector <int> inside;
    dp[0][{}] = 0;
    for (int i = 0; i < q; i++) {
        string z;
        int t;
        cin >> z >> t; t--;
        for (int mask = 0; mask < (1 << inside.size()); mask++) {
            deque <int> d;
            for (size_t j = 0; j < inside.size(); j++) {
                if ((mask >> j) & 1) {
                    d.push_back(inside[j]);
                } else {
                    d.push_front(inside[j]);
                }
            }
            if (dp[i].count(d) == 0) {
                continue;
            }
            if (z == "add") {
                deque <int> d_new = d;
                d_new.push_back(t);
                if (dp[i + 1].count(d_new) == 0) {
                    dp[i + 1][d_new] = INF;
                }
                chkMin(dp[i + 1][d_new], dp[i][d] + 1);
                d_new.pop_back();

                d_new.push_front(t);
                if (dp[i + 1].count(d_new) == 0) {
                    dp[i + 1][d_new] = INF;
                }
                chkMin(dp[i + 1][d_new], dp[i][d] + 1);
                d_new.pop_front();
            } else {
                deque <int> d_new = d;
                auto it = find(d_new.begin(), d_new.end(), t);
                int k = it - d_new.begin();
                d_new.erase(it);
                if (dp[i + 1].count(d_new) == 0) {
                    dp[i + 1][d_new] = INF;
                }
                chkMin(dp[i + 1][d_new], dp[i][d] + 2 * k + 1);
            }
        }
        if (z == "add") {
            inside.push_back(t);
        } else {
            inside.erase(find(inside.begin(), inside.end(), t));
        }
    }
    long long ans = INF;
    for (auto res : dp[q]) {
        chkMin(ans, res.second);
    }
    cout << ans << '\n';
    return 0;
}
